Type Memory = Array[0..65527] of Byte;

Var Virtual1,Virtual2: ^Memory;
    Vaddr1,Vaddr2: Word;

Procedure Setup_Memory;                 { Get memory (virtual screens) }
Begin
  GetMem(Virtual1,65528);
  Vaddr1 := Seg(Virtual1^);
  Fillchar(Virtual1^,65528,0);

  GetMem(Virtual2,65528);
  Vaddr2 := Seg(Virtual2^);
  Fillchar(Virtual2^,65528,0);

  For Loop1 := 1 to Max_Text do
  Begin
    GetMem(TexPoint[Loop1],Texture_Size);
    FillChar(TexPoint[Loop1]^,Texture_Size,0);
    Textures[Loop1] := Seg(TexPoint[Loop1]^);
  End;
End;

Procedure Release_Memory;               { Release used memory }
Begin
  FreeMem(Virtual1,65528);
  FreeMem(Virtual2,65528);
  For Loop1 := 1 to Max_Text do FreeMem(TexPoint[Loop1],Texture_Size);
End;

Procedure Back_Ground(Where: Word); Assembler;
Asm
   mov   ax,Where
   mov   es,ax
   xor   di,di
   mov   al,254
   mov   ah,al
   mov   cx,16000
   rep   stosw
   mov   al,255
   mov   ah,al
   mov   cx,16000
   rep   stosw
End;

Procedure DrawLine(x,y1,y2: Integer; C: Byte; Where: Word); Assembler;
Asm
   mov   ax,y1
   cmp   ax,0
   jg    @Oky1
   mov   ax,0
   mov   y1,ax
@Oky1:
   mov   ax,y2
   cmp   ax,199
   jb    @Oky2
   mov   ax,199
   mov   y2,ax
@Oky2:                                    { y1,y2 are clipped to screen }

   mov   ax,Where
   mov   es,ax
   mov   di,y1
   mov   ax,y1
   shl   di,8
   shl   ax,6
   add   di,ax
   add   di,x                             { es:di => destination offset }

   mov   cx,y2
   sub   cx,y1
   mov   al,C
@LoopY:
   mov   byte ptr es:[di],al
   add   di,320
   dec   cx
   jnz   @LoopY                           { Draw the slice }
End;

Procedure Draw_Texture_Slice_Pascal(Xplace,Yplace,Height,Offs,Source,Dest: Word);
Var Loop1,Step,Y: Word;
    C: Byte;
Begin
  Step := (64 shl 8) div Height;
  Y := 0;
  For Loop1 := 1 to Height do
  Begin
    C := GetPixel(Offs,Y shr 8,Source);
    SetPixel(Xplace,Loop1+Yplace,C,Dest);
    Inc(Y,Step);
  End;
End;
