Unit TextUtil;          (*      By Vulture / Outlaw Triad      *)

INTERFACE

Type FrameChars = array[1..6] of Char;

Const Frame: FrameChars = 'ɻȼ';

      Frame2: FrameChars = 'ڿ';

Procedure WriteChar(X, Y: Integer; Ch: Char; Count: Integer);
Procedure WriteXY(X, Y: Byte; Text: String);       { Writes a string at X, Y }
Procedure ClearTextScreen(Ch: Char; C: Byte);
Procedure DeleteWindow(X1, Y1, X2, Y2: Byte; Ch: Char; C: Byte);
Procedure MakeWindow(X1, Y1, X2, Y2: Byte; Text: String);
Function Keypressed: Boolean;
Procedure SetBorderColor(C: Byte);


IMPLEMENTATION

Uses Crt;

Procedure WriteChar(X, Y: Integer; Ch: Char; Count: Integer);
var A: Integer;
Begin
  GotoXY(X, Y);
  For A := 1 to Count do Write(Ch);
end;

Procedure WriteXY(X, Y: Byte; Text: String);    { Writes a string at X, Y }
Begin
  GotoXY(X, Y);
  Write(Text);
End;

Procedure ClearTextScreen(Ch: Char; C: Byte);
Var Loop1, Loop2: Byte;
Begin
  Window(1,1,80,25);
  TextColor(C);
  For Loop1 := 1 to 25 Do
    For Loop2 := 1 to 80 Do WriteChar(Loop2,Loop1,Ch,1);
End;

Procedure DeleteWindow(X1, Y1, X2, Y2: Byte; Ch: Char; C: Byte);
Var Xnr, Ynr, Loop1: Byte;
Begin
  Window(1,1,80,25);
  TextColor(C);
  Xnr := X2 - X1 + 1;
  Ynr := Y2 - Y1;
  For Loop1 := 0 to Ynr Do WriteChar(X1,Y1+Loop1, Ch, Xnr);
  Window(1,1,80,25);
End;

Procedure MakeWindow(X1, Y1, X2, Y2: Byte; Text: String);
var A, TPO, XAS, YAS: Byte;
Begin
  Window(1, 1, 80, 25);                       { Set window to entire screen }
  XAS  := X2 - X1;
  YAS  := Y2 - Y1;
  Text := '[ ' + Text + ' ]';
  TPO  := (XAS - Length(Text)) div 2;

  Textbackground(7);
  Textcolor(15);
  WriteChar(X1, Y1, Frame2[1], 1);            { Draws top of window }
  WriteChar(X1 + 1, Y1, Frame2[4], XAS);
  WriteXY(X1 + TPO, Y1, Text);

  Textcolor(8);
  WriteChar(X2, Y1, Frame2[2], 1);

  For A := 1 to YAS do                        { Draws middle of window }
  Begin
    Textcolor(15);
    WriteChar(X1, Y1 + A, Frame2[3], 1);
    Textcolor(8);
    WriteChar(X2, Y1 + A, Frame2[3], 1);
  End;

  Textcolor(15);
  WriteChar(X1, Y2, Frame2[5], 1);            { Draws bottom of window }
  Textcolor(8);
  WriteChar(X1 + 1, Y2, Frame2[4], XAS);
  WriteChar(X2, Y2, Frame2[6], 1);
  DeleteWindow(X1 + 1, Y1 + 1, X2 - 1, Y2 - 1,' ',7);
  Window(X1 + 2, Y1 + 1, X2 - 2, Y2 - 1);     { Set current window }
End;

Function Keypressed: Boolean;
var Key: Byte;
Begin
  Asm
    Mov AH, $B
    Int $21      { Reads a key from da keyboard }
    Mov Key, AL  { Case AL=0,No key pressed; AL=$FF means keypressed }
  End;
  If Key <> 0 then Keypressed := True;
End;

Procedure SetBorderColor(C: Byte); ASSEMBLER; { Sets background & border color }
Asm
  mov AH, 0Bh         { Fuction number in AH }
  mov BH, 00h
  mov BL, C
  int 10h             { Execute command }
End;

END. { TextUtil }